#!/usr/bin/env python
from gimpfu import *

# https://gimplearn.net/viewtopic.php?f=3&t=723
'''
################################
# BA_Photomaster's Text Blocks #
################################ 
Based on Photomaster's tutorial Marble Cut Slab from GimpChat
Brian Andersen June 2017
needs mh3dbevel --- explaination in other version
Also needs Script-Fu-Drop-Shadow
(as shown in Filters>Python-Fu>Console>Browse
and search for Fu_Drop (with underscore instead
of hyphen) 
version 2
added a Multi Extrusion Effect
and warning message when ID count approaching script limit
  ...................................................... 
####################
# COPYRIGHT NOTICE #
###############################################################################
# This program is free software you can redistribute it and/or modify         #
# it under the terms of the GNU General Public License as published by        #
# the Free Software Foundation either version 3 of the License, or            #
# (at your option) any later version.                                         #
# This program is distributed in the hope that it will be useful,             #
# but WITHOUT ANY WARRANTY without even the implied warranty of               #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               #
# GNU General Public License for more details.                                #
# You should have received a copy of the GNU General Public License           #
# along with this program if not, you can view the GNU General Public         #
# License version 3 at the web site http://www.gnu.org/licenses/gpl-3.0.html  #
# Alternatively you can write to the Free Software Foundation, Inc., 675 Mass #
# Ave, Cambridge, MA 02139, USA.                                              #
###############################################################################

#'''


def multiloop(bugloop,sizeup1,pat1,dbev1,dir):
    loopit = 0
    while loopit < bugloop:
        inimage = gimp.image_list()[0]
        indrawable = inimage.layers[0]
        iwidth  = inimage.width
        iheight = inimage.height
        itype   = inimage.base_type
        img1 = pdb.gimp_image_new (iwidth, iheight, itype)
        pdb.gimp_display_new(img1)
        img1lay0 = pdb.gimp_layer_new_from_drawable(indrawable,img1) 
        img1.add_layer(img1lay0)
        alpha=pdb.gimp_drawable_has_alpha(img1lay0)
        if not alpha:
            pdb.gimp_layer_add_alpha (img1lay0)
        img1lay0.mode=LAYER_MODE_NORMAL_LEGACY
        img1lay0.opacity=100.0
        pdb.gimp_item_set_visible(img1lay0,1)
        pdb.gimp_selection_layer_alpha(img1lay0)
        non_empty, x1, y1, x2, y2 = pdb.gimp_selection_bounds(img1)
        pdb.gimp_selection_none(img1)
        cropwidth = x2-x1
        cropheight= y2-y1
        pdb.gimp_image_crop(img1,cropwidth,cropheight,x1,y1)
        pdb.gimp_layer_resize(img1lay0,cropwidth+sizeup1,cropheight+sizeup1,0,0)
        pdb.gimp_image_resize_to_layers(img1)
        pdb.gimp_layer_set_offsets(img1lay0, sizeup1/2,sizeup1/2)
        pdb.gimp_layer_resize_to_image_size(img1lay0)
        pdb.gimp_context_set_pattern(pat1)
        img1lay1=pdb.gimp_layer_new(img1,cropwidth+sizeup1,cropheight+sizeup1,1,'inlay1',100,0)
        pdb.gimp_image_insert_layer(img1,img1lay1,None,0)
        pdb.gimp_drawable_fill(img1lay1, 4)
        pdb.gimp_image_set_active_layer(img1,img1lay0)
        pdb.gimp_selection_layer_alpha(img1lay0)
        pdb.gimp_image_set_active_layer(img1, img1lay1)
        non_empty = pdb.gimp_edit_cut(img1lay1)
        pdb.gimp_item_set_visible(img1lay0, False)
        pdb.gimp_selection_none(img1)
        loopit+=1
        pdb.script_fu_mhbevel3dimg22(img1,img1lay1,1,dbev1,dir,1,5,3,0,0) 
       #imageslist=gimp.image_list()
       #imgcnt=len(imageslist)
       #pdb.gimp_message('loopit,ipos,imgcnt: '+str(loopit)+","+str(ipos)+","+str(imgcnt))
       # gimp.delete(gimp._id2display((delist[int(ipos)])))



    return()

### END FUNCTION Intensify_Custom <<<<-------------------------------------------

def BA_PhotomasterBlockv2M (inImage, inDrawable,
                         sizeup1, thlc, pat1, dbev1,
                         sizeup2, bhlc, pat2, dbev2, 
                         sizeup3, pat3, col3, bumpheight,
                         alternate, bugloop,): 

    pdb.gimp_context_push()
    pdb.gimp_context_set_defaults()
	
    alpha=pdb.gimp_drawable_has_alpha(inDrawable)
    if not alpha:
        pdb.gimp_layer_add_alpha (inDrawable)
		
    width  = inImage.width
    height = inImage.height
    type   = inImage.base_type
    name   = inImage.name
    dir = 0 #direction of extrude - not used in menu yet.

    img1 = pdb.gimp_image_new (width, height, type)
    pdb.gimp_display_new(img1)
    img1lay0 = pdb.gimp_layer_new_from_drawable(inDrawable, img1) 
    pdb.gimp_image_set_filename(img1,"Original")
    img1.add_layer(img1lay0)
    img1lay0=img1.layers[0]
    img1lay0.name="Subject Original"
    img1lay0.mode=LAYER_MODE_NORMAL_LEGACY
    img1lay0.opacity=100.0
    pdb.gimp_item_set_visible(img1lay0,1)

    alpha=pdb.gimp_drawable_has_alpha(img1lay0)
    if not alpha:
        pdb.gimp_layer_add_alpha (img1lay0)    

    pdb.gimp_selection_layer_alpha(img1lay0)
    non_empty, x1, y1, x2, y2 = pdb.gimp_selection_bounds(img1)
    pdb.gimp_selection_none(img1)
    if non_empty:
        cropwidth = x2-x1
        cropheight= y2-y1
    else:
        pdb.gimp_message('SCRIPT USES A TEXT LAYER!!!\n Script Ended')
    #pdb.gimp_image_set_active_layer(img1, img1lay0)
    pdb.gimp_image_crop(img1,cropwidth,cropheight,x1,y1)

    pdb.gimp_layer_resize(img1lay0,cropwidth+sizeup1,cropheight+sizeup1,0,0)
    pdb.gimp_image_resize_to_layers(img1)
    pdb.gimp_layer_set_offsets(img1lay0, sizeup1/2,sizeup1/2)
    pdb.gimp_layer_resize_to_image_size(img1lay0)

    pdb.gimp_context_set_pattern(pat1)
    img1lay1=pdb.gimp_layer_new(img1,cropwidth+sizeup1,cropheight+sizeup1,1,'inlay1',100,0)
    pdb.gimp_image_insert_layer(img1,img1lay1,None,0)
    pdb.gimp_drawable_fill(img1lay1, 4)
    pdb.gimp_image_set_active_layer(img1,img1lay0)
    pdb.gimp_selection_layer_alpha(img1lay0)
    pdb.gimp_image_set_active_layer(img1, img1lay1)
    non_empty = pdb.gimp_edit_cut(img1lay1)
    pdb.gimp_item_set_visible(img1lay0, False)
    pdb.gimp_selection_none(img1)
########################################    
    if alternate:
        delist=[] # remove intermediate images
        loop = 0
        while loop < 1500:
            valid = pdb.gimp_display_is_valid(gimp._id2display(int(loop)))
            if valid:
                delist.insert(loop,loop)
            loop+=1
        tosave=len(delist)
        ###
        multiloop(bugloop,sizeup1,pat1,dbev1,dir)
        ###
        pdb.gimp_displays_flush
        delist=[] # remove intermediate images
        loop = 0
        while loop < 1500:
            valid = pdb.gimp_display_is_valid(gimp._id2display(int(loop)))
            if valid:
                delist.insert(loop,loop)
            loop+=1
        todelete=delist[(int(tosave)-1):-1]
        for i in delist:
            if i > 1200:
                pdb.gimp_message('Session Cache growing full')
                pdb.gimp_message('Please save & restart Gimp')
        for i in todelete:
            gimp.delete(gimp._id2display(i))
        img2=gimp.image_list()[0]
        pdb.gimp_image_resize_to_layers(img2)
        img2lay0,img2lay1,img2lay2=img2.layers
        pdb.gimp_layer_resize_to_image_size(img2lay0)
        ### apply highlights
        pdb.gimp_context_set_foreground(thlc)
        pdb.gimp_context_set_brush("2. Hardness 100")
        pdb.gimp_context_set_brush_size(1)
        pdb.gimp_image_select_item(img2,0,img2lay0)
        pdb.gimp_edit_stroke(img2lay0)
        pdb.gimp_selection_none(img2)
        ### clean up and exit from multiloop option
        pdb.gimp_context_pop()
        pdb.gimp_displays_flush
        return()
###### if alternate chosen-stop here
########################################

#### the first bevel
    pdb.script_fu_mhbevel3dimg22(img1,img1lay1,1,dbev1,dir,1,5,3,0,0) 

#### get bevel layer (and used same to add new layers at the same time)
    img2=gimp.image_list()[0]
    for i in (img2.layers):
        pdb.gimp_layer_resize_to_image_size(i)
    
    img2lay0,img2lay1,img2lay2=img2.layers
    img2lay0.name="img2lay1 line102"

    face_width =img2.width
    face_height=img2.height
    pdb.gimp_image_resize(img1, face_width, face_height,0,0)
    for i in reversed(img2.layers):
        lay_x=pdb.gimp_layer_new_from_drawable(i,img1)
        img1.add_layer(lay_x,0)
        lay_x=pdb.gimp_layer_new_from_drawable(i,img1)
        img1.add_layer(lay_x,0)
        lay_x=pdb.gimp_layer_new_from_drawable(i,img1)
        img1.add_layer(lay_x,0)

    delist=[]  
    loop = 0
    while loop < 1500:
        valid = pdb.gimp_display_is_valid(gimp._id2display(int(loop)))
        if valid:
            delist.insert(loop,loop)
        loop+=1
        for i in delist:
            if i > 1200:
                pdb.gimp_message('Session Cache growing full')
                pdb.gimp_message('Please save & restart Gimp')
    ipos=len(delist)-1
    gimp.delete(gimp._id2display((delist[int(ipos)])))

    #refresh layers
    img1lay1,img1lay2,img1lay3,img1lay4,img1lay5,img1lay6,img1lay7,img1lay8,img1lay9,img1lay10,img1lay11=img1.layers

    pdb.gimp_layer_resize_to_image_size(img1lay1)
    pdb.gimp_layer_resize_to_image_size(img1lay2)

    img1lay1.name = 'Top Edge Highlight'
    pdb.gimp_edit_clear(img1lay1)
    img1lay2.name = 'Top Face-cut'
    img1lay3.name = 'Slab Highlight'
    pdb.gimp_edit_clear(img1lay3)
    pdb.gimp_image_lower_item_to_bottom(img1,img1lay3)
    img1lay4.name = 'Top Extrusion dark-cut'
    pdb.gimp_selection_layer_alpha(img1lay2)
    pdb.gimp_edit_clear(img1lay4)
    non_empty, x1, y1, x2, y2 = pdb.gimp_selection_bounds(img1)
    pdb.gimp_image_select_rectangle(img1, 0, x1, y1, x2-x1,y2-y1)
    pdb.gimp_edit_clear(img1lay4)
    pdb.gimp_selection_none(img1)
    pdb.gimp_curves_spline(img1lay4,0,8,(0,0,2,1,4,15,150,90))
    img1lay5.name = 'Subject Extrusion-cut'
    img1lay6.name = 'Top Extrusion light-cut'
    img1lay7.name = 'Top Subject -extrusion'
    img1lay9.name = 'Top Face Highlight'
    pdb.gimp_edit_clear(img1lay9)
    img1lay10.name = 'Top Face'
    img1lay11.name = 'Top Subject'
    pdb.gimp_image_remove_layer(img1,img1lay8)
    img1lay8=img1lay11.copy(True)
    img1.add_layer(img1lay8,6)
    img1lay8.name = 'Subject -not extruded'
    for i in img1.layers:
        pdb.gimp_item_set_visible(i, False)

    img1lay1,img1lay2,img1lay3,img1lay4,img1lay5,img1lay6,img1lay7,img1lay8,img1lay9,img1lay10,img1lay11=img1.layers

    pdb.gimp_image_select_item(img1,0,img1lay2)
    pdb.gimp_edit_clear(img1lay4)
    non_empty, x1, y1, x2, y2 = pdb.gimp_selection_bounds(img1)
    pdb.gimp_image_select_rectangle(img1, 0, x1, y1, x2-x1,y2-y1)
    pdb.gimp_edit_clear(img1lay5) 
    pdb.gimp_image_select_item(img1,2,img1lay5)
    pdb.gimp_edit_clear(img1lay4)
    pdb.gimp_selection_none(img1)

    pdb.gimp_context_set_foreground(thlc)
    pdb.gimp_context_set_brush("2. Hardness 100")
    pdb.gimp_context_set_brush_size(1)
    pdb.gimp_image_select_item(img1,0,img1lay2)
    pdb.gimp_edit_stroke(img1lay1)
    pdb.gimp_selection_none(img1)
 
    img1=gimp.image_list()[0] #refresh static img1
    img1lay1,img1lay2,img1lay3,img1lay4,img1lay5,img1lay6,img1lay7,img1lay8,img1lay9,img1lay10,img1lay11=img1.layers  

    position = pdb.gimp_image_get_item_position(img1,img1lay1)
    # params: image,drawable, offx, offy, blur, color, opacity, allow resize
    pdb.script_fu_drop_shadow(img1,img1lay1,4,4,15,'#000000',60,0)
    drop1=img1.layers[(position+1)]  
    drop1.name='Highlight Dropshadow'
    position = pdb.gimp_image_get_item_position(img1,img1lay2)   
    pdb.script_fu_drop_shadow(img1,img1lay2,4,4,15,'#000000',60,0)
    drop2=img1.layers[(position+1)]
    drop2.name='Top Face Dropshadow'
    position = pdb.gimp_image_get_item_position(img1,img1lay4)
    pdb.script_fu_drop_shadow(img1,img1lay4,4,4,15,'#000000',60,0)
    drop3=img1.layers[(position+1)]
    drop3.name='Subject Extrusion Dropshadow'
    position = pdb.gimp_image_get_item_position(img1,img1lay5)
    pdb.script_fu_drop_shadow(img1,img1lay5,8,8,15,'#000000',60,0)
    drop5=img1.layers[(position+1)]
    drop5.name='Top Extrusion Dropshadow' 

    szup2w = face_width + sizeup2 + dbev2
    szup2h = face_height+ sizeup2 + dbev2
    offsetw = int(sizeup2/2)+dbev2/2 
    offseth = int(sizeup2/2)+dbev2/2
    pdb.gimp_image_resize(img1, szup2w, szup2h, offsetw, offseth)

    slabLay = pdb.gimp_layer_new(img1,szup2w,szup2h,1,'Slab RH',100.0,LAYER_MODE_NORMAL_LEGACY)
    img1.add_layer(slabLay,15)
    pdb.gimp_image_set_active_layer(img1,slabLay)
    pdb.gimp_context_set_pattern(pat2)
    pdb.gimp_drawable_fill(slabLay, 4)
    #### the 2nd bevel
    pdb.script_fu_mhbevel3dimg22(img1,slabLay,1,dbev2,dir,1,5,3,0,0)  ##### 2nd bevel ###########################

    # Remove all layers except the bevel layer from img3
    img3 = gimp.image_list()[0]
    dlaylist = img3.layers[:-1]
    for i in (dlaylist):
        pdb.gimp_image_remove_layer(img3,i)
    for i in reversed(img3.layers):
        lay_x=pdb.gimp_layer_new_from_drawable(i,img1)
        img1.add_layer(lay_x,16)
  
    delist=[] # remove image 3
    loop = 0
    while loop < 1500:
        valid = pdb.gimp_display_is_valid(gimp._id2display(int(loop)))
        if valid:
            delist.insert(loop,loop)
        loop+=1
    ipos=len(delist)-1
    gimp.delete(gimp._id2display((delist[int(ipos)])))
    pdb.gimp_image_delete(img3)

    img1lay16 = img1.layers[15]
    img1lay17 = img1.layers[16]
    img1lay16.name='Mid Face'
    img1lay17.name='Mid Face Extruded Dark'
    img1lay18=pdb.gimp_layer_copy(img1lay17,1)
    pdb.gimp_image_add_layer(img1,img1lay18,20)
    img1lay18.name='Mid Face Extruded Light'
    pdb.gimp_curves_spline(img1lay17,0,8,(0,0,2,1,4,15,150,90))
    pdb.gimp_image_resize_to_layers(img1)

    #refresh layer list
    img1 = gimp.image_list()[0]
    img1lay1,img1lay2,img1lay3,img1lay4,img1lay5,img1lay6,img1lay7,img1lay8,img1lay9,img1lay10,img1lay11,img1lay12,img1lay13,img1lay14,img1lay15,img1lay16,img1lay17,img1lay18=img1.layers
    #more highlights
    pdb.gimp_image_set_active_layer(img1,img1lay13)
    pdb.gimp_selection_layer_alpha(img1lay13)
    pdb.gimp_context_set_foreground(thlc)
    pdb.gimp_layer_resize_to_image_size(img1lay12)
    pdb.gimp_layer_resize_to_image_size(img1lay13)
    pdb.gimp_edit_stroke(img1lay12)
    pdb.gimp_selection_none(img1)
    pdb.gimp_image_set_active_layer(img1,img1lay16)
    pdb.gimp_selection_layer_alpha(img1lay16)
    pdb.gimp_context_set_foreground(bhlc)
    pdb.gimp_layer_resize_to_image_size(img1lay15) #it was small
    pdb.gimp_edit_stroke(img1lay15)
    pdb.gimp_selection_none(img1)

    szup3w = szup2w+sizeup3 
    szup3h = szup2h+sizeup3
    offsetw = int(sizeup3)
    offseth = int(sizeup3)
    pdb.gimp_image_resize(img1, szup3w, szup3h, offsetw, offseth)
    img1lay19=pdb.gimp_layer_new(img1,szup3w,szup3h,1,"Wall",100,LAYER_MODE_NORMAL_LEGACY)
    pdb.gimp_image_insert_layer(img1,img1lay19,None,20) 
    pdb.gimp_image_resize_to_layers(img1)
    img1lay20= pdb.gimp_layer_copy(img1lay19,1)
    img1lay20.name='Bump Map'
    pdb.gimp_image_add_layer(img1,img1lay20,20)

    #refresh layer list
    img1lay1,img1lay2,img1lay3,img1lay4,img1lay5,img1lay6,img1lay7,img1lay8,img1lay9,img1lay10,img1lay11,img1lay12,img1lay13,img1lay14,img1lay15,img1lay16,img1lay17,img1lay18,img1lay19,img1lay20=img1.layers

    img1=gimp.image_list()[0]
    mlink=img1.layers[:-1]
    for i in range(len(mlink)):
        pdb.gimp_item_set_linked(mlink[i],1)  
    pos_x=sizeup3/2
    pos_y=sizeup3/2
    pdb.gimp_layer_set_offsets(img1lay16,pos_x,pos_y)
    for i in range(len(mlink)):
        pdb.gimp_item_set_linked(mlink[i],0)
   
    layerlist=img1.layers
    full=layerlist[0:]
    for i in range(len(full)):
        pdb.gimp_layer_resize_to_image_size(full[i])

    #cut slab face extrusion layers
    pdb.gimp_selection_layer_alpha(img1lay16)
    pdb.gimp_edit_clear(img1lay17)
    pdb.gimp_edit_clear(img1lay18)
    pdb.gimp_selection_none(img1)
    pdb.script_fu_drop_shadow(img1,img1lay17,dbev2-10,dbev2-10,15,'#000000',60,0)
    #move up 2 positions - vis off
    pdb.gimp_image_raise_item(img1,img1lay18)    
    pdb.gimp_image_raise_item(img1,img1lay18)

    #color 'wall'
    pdb.gimp_context_set_foreground(col3)
    pdb.gimp_layer_resize_to_image_size(img1lay19)
    pdb.gimp_edit_fill(img1lay19, 0)
    #bump map the wall
    pdb.gimp_context_set_pattern(pat3)
    pdb.gimp_drawable_fill(img1lay20,4)
    pdb.plug_in_bump_map(img1,img1lay19,img1lay20,135,45,bumpheight,0,0,0,0,1,0,0)

    layerlist=img1.layers
    full=layerlist
    for i in range(len(layerlist)):
        pdb.gimp_layer_resize_to_image_size(full[i])
        pdb.gimp_item_set_visible(full[i],1) #doesn't affect layers within groups
    pdb.gimp_item_set_visible(img1lay11,0)
    pdb.gimp_item_set_visible(img1lay18,0)

    part=layerlist[:-11]      
    for i in range(len(part)):
        pdb.gimp_item_set_linked(part[i],1)

#### make layer group for extruded and non extruded face
    group2 = pdb.gimp_layer_group_new(img1)
    pdb.gimp_image_insert_layer(img1,group2,None,1)
    group2.name='Top Face Extruded Group'

#### fill group2
    pdb.gimp_image_reorder_item(img1,img1lay10,group2,0)
    pdb.gimp_image_reorder_item(img1,img1lay11,None,0) 
    pdb.gimp_image_reorder_item(img1,img1lay7 ,group2,0)
    pdb.gimp_item_set_visible(img1lay7,0)
    pdb.gimp_image_reorder_item(img1,img1lay6 ,group2,0)
    pdb.gimp_image_reorder_item(img1,img1lay9 ,group2,0)
    pdb.gimp_image_reorder_item(img1,img1lay5 ,group2,0)
    pdb.gimp_image_reorder_item(img1,img1lay8 ,group2,0)
    pdb.gimp_item_set_visible(img1lay8,0) 
    pdb.gimp_image_reorder_item(img1,img1lay4 ,group2,0)
    pdb.gimp_item_set_visible(img1lay4,0)
    pdb.gimp_image_reorder_item(img1,img1lay3 ,group2,0)
    pdb.gimp_image_reorder_item(img1,img1lay2 ,group2,0)
    pdb.gimp_item_set_visible(img1lay2,0)
    pdb.gimp_image_reorder_item(img1,img1lay1 ,group2,0)

#### create and fill group1 
    group1 = pdb.gimp_layer_group_new(img1)
    pdb.gimp_image_insert_layer(img1,group1,None,1)
    group1.name='Top Subject not extruded'
    pdb.gimp_image_reorder_item(img1,img1lay14,group1,0)
    pdb.gimp_image_reorder_item(img1,img1lay13,group1,0)
    pdb.gimp_image_reorder_item(img1,img1lay12,group1,0)
    pdb.gimp_item_set_visible(group1,0)

    
    #cleanup and done 
    pdb.gimp_context_pop()
    #pdb.gimp_display_new(img1)
    pdb.gimp_displays_flush
    pdb.gimp_image_set_filename(img1, "BA_PhotomasterBlockv2M_"+str(delist[int(ipos)]))
    return()

register(
    "BA_PhotomasterBlockv2M",    
    "Automates an Extrusion Play.Must have Bevel3D.scm.",   
    "Extrusion",
    "Brian", 
    "Brian Andersen ", 
    "Jun 2017",
    "BA PhotomasterBlock with MultiLoop...", 
    "RGB*", 
    [
      (PF_IMAGE,   "inImage",    "Input image",            None),
      (PF_DRAWABLE,"inDrawable", "Input drawable",         None),
      (PF_SPINNER, "sizeup1",    "Top Block Text Border",  50,(2,200,2)),
      (PF_COLOR,   "thlc",       "Top Block Highlight Color", (0,0,0)),
      (PF_PATTERN, "pat1",       "Top Block Pattern",      None),
      (PF_SPINNER, "dbev1",      "Top Block 3D in pixels", 20,(2,200,1)),
      (PF_SPINNER, "sizeup2",    "Size Up for 2nd Block", 250,(2,500,2)),
      (PF_COLOR,   "bhlc",       "2nd Block Highlight Color",(0,0,0)),
      (PF_PATTERN, "pat2",       "2nd Blcok Pattern",      None),
      (PF_SPINNER, "dbev2",      "Second Block 3D in pixels", 20,(2,200,1)),
      (PF_SPINNER, "sizeup3",    "Size Up for Wall",         250,(2,500,2)),
      (PF_PATTERN, "pat3",       "Bump Pattern for Wall",  None),
      (PF_COLOR,   "col3",       "Wall Color",             (0,0,0,)),
      (PF_SPINNER, "bumpheight", "Bump map height for Wall",   1,(1, 30,1)),
      (PF_BOOL,    "alternate",  "Multi Extrude Effect",   False),
      (PF_SPINNER, "bugloop",    "Multi Extrude Passes",  3,(1,30,1)),
     
    ], 
    [],
    BA_PhotomasterBlockv2M,
    menu="<Image>/Filters/Artistic/Brian/",
    )

main()
